(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/cdk/overlay'), require('@angular/cdk/portal'), require('@js-sugar/angular')) :
    typeof define === 'function' && define.amd ? define('@js-sugar/angular-bootstrap', ['exports', '@angular/core', '@angular/common', '@angular/cdk/overlay', '@angular/cdk/portal', '@js-sugar/angular'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['js-sugar'] = global['js-sugar'] || {}, global['js-sugar']['angular-bootstrap'] = {}), global.ng.core, global.ng.common, global.ng.cdk.overlay, global.ng.cdk.portal, global.angular));
}(this, (function (exports, core, common, overlay, portal, angular) { 'use strict';

    var BadgeDirective = /** @class */ (function () {
        function BadgeDirective(_el, _renderer) {
            this._el = _el;
            this._renderer = _renderer;
            this.color = 'primary';
            this.pill = false;
        }
        BadgeDirective.prototype.ngOnInit = function () {
            this._renderer.addClass(this._el.nativeElement, 'badge');
        };
        return BadgeDirective;
    }());
    BadgeDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[jssBadge]',
                    exportAs: 'jssBadge',
                    host: {
                        '[class.bg-primary]': 'color=="primary"',
                        '[class.bg-secondary]': 'color=="secondary"',
                        '[class.bg-success]': 'color=="success"',
                        '[class.bg-danger]': 'color=="danger"',
                        '[class.bg-warning]': 'color=="warning"',
                        '[class.bg-info]': 'color=="info"',
                        '[class.bg-light]': 'color=="light"',
                        '[class.bg-dark]': 'color=="dark"',
                        '[class.rounded-pill]': 'pill',
                    }
                },] }
    ];
    BadgeDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 }
    ]; };
    BadgeDirective.propDecorators = {
        color: [{ type: core.Input, args: ['jssBadge',] }],
        pill: [{ type: core.Input }]
    };

    var BadgeModule = /** @class */ (function () {
        function BadgeModule() {
        }
        return BadgeModule;
    }());
    BadgeModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        BadgeDirective
                    ],
                    exports: [
                        BadgeDirective
                    ]
                },] }
    ];

    var BreadcrumbItemTemplateDirective = /** @class */ (function () {
        function BreadcrumbItemTemplateDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return BreadcrumbItemTemplateDirective;
    }());
    BreadcrumbItemTemplateDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[jssBreadcrumbItemTemplate]',
                    exportAs: 'jssBreadcrumbItemTemplate',
                },] }
    ];
    BreadcrumbItemTemplateDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };

    var BreadcrumbComponent = /** @class */ (function () {
        function BreadcrumbComponent(_el, _renderer) {
            this._el = _el;
            this._renderer = _renderer;
            this.itemClick = new core.EventEmitter();
        }
        BreadcrumbComponent.prototype.ngOnInit = function () {
            this._renderer.setAttribute(this._el.nativeElement, 'role', 'navigation');
        };
        return BreadcrumbComponent;
    }());
    BreadcrumbComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'jss-breadcrumb',
                    exportAs: 'jssBreadcrumb',
                    template: "<nav aria-label=\"breadcrumb\">\r\n    <ol class=\"breadcrumb\">\r\n        <li\r\n            *ngFor=\"let item of items\"\r\n            [class.text-muted]=\"item.disabled\"\r\n            [class.active]=\"!item.disabled && item.active\"\r\n            (click)=\"item.disabled ? 0 : itemClick.emit({item: item, event: $event})\"\r\n            class=\"breadcrumb-item\">\r\n\r\n            <ng-container *ngIf=\"_itemTemplate\" [ngTemplateOutlet]=\"_itemTemplate.templateRef\"\r\n                          [ngTemplateOutletContext]=\"{$implicit: item}\">\r\n            </ng-container>\r\n            {{item.text}}\r\n        </li>\r\n    </ol>\r\n</nav>\r\n",
                    styles: [':host {display: block;}']
                },] }
    ];
    BreadcrumbComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 }
    ]; };
    BreadcrumbComponent.propDecorators = {
        items: [{ type: core.Input }],
        itemClick: [{ type: core.Output }],
        _itemTemplate: [{ type: core.ContentChild, args: [BreadcrumbItemTemplateDirective,] }]
    };

    var BreadcrumbModule = /** @class */ (function () {
        function BreadcrumbModule() {
        }
        return BreadcrumbModule;
    }());
    BreadcrumbModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                    ],
                    declarations: [
                        BreadcrumbComponent,
                        BreadcrumbItemTemplateDirective
                    ],
                    exports: [
                        BreadcrumbComponent,
                        BreadcrumbItemTemplateDirective
                    ]
                },] }
    ];

    var ButtonDirective = /** @class */ (function () {
        function ButtonDirective(_element, _renderer) {
            this._element = _element;
            this._renderer = _renderer;
            this.size = 'default';
            this.kind = 'primary';
            this.safeClick = new core.EventEmitter();
        }
        ButtonDirective.prototype.ngOnInit = function () {
            this._renderer.addClass(this._element.nativeElement, 'btn');
        };
        ButtonDirective.prototype._onClick = function (e) {
            if (!this.disabled) {
                this.safeClick.emit(e);
            }
        };
        return ButtonDirective;
    }());
    ButtonDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: 'button[jssButton], a[jssButton], input[jssButton]',
                    exportAs: 'jssButton',
                    host: {
                        '[class.disabled]': 'disabled',
                        '[class.btn-primary]': '!outline && kind=="primary"',
                        '[class.btn-secondary]': '!outline && kind=="secondary"',
                        '[class.btn-success]': '!outline && kind=="success"',
                        '[class.btn-danger]': '!outline && kind=="danger"',
                        '[class.btn-warning]': '!outline && kind=="warning"',
                        '[class.btn-info]': '!outline && kind=="info"',
                        '[class.btn-light]': '!outline && kind=="light"',
                        '[class.btn-dark]': '!outline && kind=="dark"',
                        '[class.btn-link]': 'kind=="link"',
                        '[class.btn-outline-primary]': 'outline && kind=="primary"',
                        '[class.btn-outline-secondary]': 'outline && kind=="secondary"',
                        '[class.btn-outline-success]': 'outline && kind=="success"',
                        '[class.btn-outline-danger]': 'outline && kind=="danger"',
                        '[class.btn-outline-warning]': 'outline && kind=="warning"',
                        '[class.btn-outline-info]': 'outline && kind=="info"',
                        '[class.btn-outline-light]': 'outline && kind=="light"',
                        '[class.btn-outline-dark]': 'outline && kind=="dark"',
                        '[class.btn-sm]': 'size=="small"',
                        '[class.btn-lg]': 'size=="large"',
                        '[attr.disabled]': 'disabled',
                        '[attr.aria-disabled]': 'disabled',
                        '[attr.tabindex]': 'disabled ? "-1" : "" ',
                    }
                },] }
    ];
    ButtonDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 }
    ]; };
    ButtonDirective.propDecorators = {
        disabled: [{ type: core.Input }],
        size: [{ type: core.Input }],
        kind: [{ type: core.Input }],
        safeClick: [{ type: core.Output }],
        _onClick: [{ type: core.HostListener, args: ['click', ['$event'],] }]
    };

    var ButtonModule = /** @class */ (function () {
        function ButtonModule() {
        }
        return ButtonModule;
    }());
    ButtonModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        ButtonDirective,
                    ],
                    exports: [
                        ButtonDirective,
                    ]
                },] }
    ];

    var CardFooterDirective = /** @class */ (function () {
        function CardFooterDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return CardFooterDirective;
    }());
    CardFooterDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[jssCardFooter]',
                    exportAs: 'jssCardFooter',
                },] }
    ];
    CardFooterDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };

    var CardHeaderDirective = /** @class */ (function () {
        function CardHeaderDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return CardHeaderDirective;
    }());
    CardHeaderDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[jssCardHeader]',
                    exportAs: 'jssCardHeader',
                },] }
    ];
    CardHeaderDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };

    var CardComponent = /** @class */ (function () {
        function CardComponent(_element, _renderer) {
            this._element = _element;
            this._renderer = _renderer;
        }
        CardComponent.prototype.ngOnInit = function () {
            this._renderer.addClass(this._element.nativeElement, 'card');
        };
        return CardComponent;
    }());
    CardComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'jss-card',
                    exportAs: 'jssCard',
                    template: "<div *ngIf=\"_header\" class=\"card-header\">\r\n    <ng-container [ngTemplateOutlet]=\"_header.templateRef\"></ng-container>\r\n</div>\r\n\r\n<div class=\"card-body\">\r\n    <ng-content></ng-content>\r\n</div>\r\n\r\n<div *ngIf=\"_footer\" class=\"card-footer\">\r\n    <ng-container [ngTemplateOutlet]=\"_footer.templateRef\"></ng-container>\r\n</div>\r\n",
                    styles: [":host{display:block}"]
                },] }
    ];
    CardComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 }
    ]; };
    CardComponent.propDecorators = {
        _header: [{ type: core.ContentChild, args: [CardHeaderDirective,] }],
        _footer: [{ type: core.ContentChild, args: [CardFooterDirective,] }]
    };

    var DECLARES = [
        CardComponent,
        CardFooterDirective,
        CardHeaderDirective
    ];
    var CardModule = /** @class */ (function () {
        function CardModule() {
        }
        return CardModule;
    }());
    CardModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule
                    ],
                    declarations: DECLARES,
                    exports: DECLARES
                },] }
    ];

    var NavbarCollapseDirective = /** @class */ (function () {
        function NavbarCollapseDirective() {
            this.collapsed = true;
        }
        return NavbarCollapseDirective;
    }());
    NavbarCollapseDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[jssNavbarCollapse]',
                    exportAs: 'jsNavbarCollapse',
                    host: {
                        '[class.show]': '!collapsed',
                    },
                },] }
    ];
    NavbarCollapseDirective.ctorParameters = function () { return []; };
    NavbarCollapseDirective.propDecorators = {
        collapsed: [{ type: core.Input, args: ['jsNavbarCollapse',] }]
    };

    var NavbarModule = /** @class */ (function () {
        function NavbarModule() {
        }
        return NavbarModule;
    }());
    NavbarModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NavbarCollapseDirective
                    ],
                    exports: [
                        NavbarCollapseDirective
                    ]
                },] }
    ];

    var PopoverWrapperComponent = /** @class */ (function () {
        function PopoverWrapperComponent(_elementRef, _renderer) {
            this._elementRef = _elementRef;
            this._renderer = _renderer;
        }
        PopoverWrapperComponent.prototype.ngOnInit = function () {
            var _this = this;
            var e = this._elementRef.nativeElement;
            this._renderer.setAttribute(e, 'role', 'tooltip');
            this._renderer.setStyle(e, 'margin', '.5rem');
            ['popover', 'fade', 'show'].forEach(function (c) { return _this._renderer.addClass(e, c); });
        };
        Object.defineProperty(PopoverWrapperComponent.prototype, "_isStringContent", {
            get: function () {
                return typeof this.content === 'string';
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PopoverWrapperComponent.prototype, "_cssClass", {
            get: function () {
                var r = {};
                r['bs-popover-' + this.placement] = true;
                return r;
            },
            enumerable: false,
            configurable: true
        });
        return PopoverWrapperComponent;
    }());
    PopoverWrapperComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'jss-popover-wrapper',
                    exportAs: 'jssPopoverWrapper',
                    template: "<div class=\"popover-arrow\"></div>\r\n<h3 class=\"popover-header\">{{title}}</h3>\r\n<div class=\"popover-body\">\r\n    <ng-template [ngIf]=\"_isStringContent\" [ngIfElse]=\"contentTemplate\">{{content}}</ng-template>\r\n\r\n    <ng-template #contentTemplate>\r\n        <ng-container [ngTemplateOutlet]=\"content\"></ng-container>\r\n    </ng-template>\r\n</div>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [":host{position:relative}:host.bs-popover-bottom .popover-arrow,:host.bs-popover-top .popover-arrow{left:calc(50% - .5rem)}:host.bs-popover-end .popover-arrow,:host.bs-popover-start .popover-arrow{top:calc(50% - .5rem)}"]
                },] }
    ];
    PopoverWrapperComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 }
    ]; };
    PopoverWrapperComponent.propDecorators = {
        _cssClass: [{ type: core.HostBinding, args: ['class',] }]
    };

    var PopoverDirective = /** @class */ (function () {
        function PopoverDirective(_overlayService, _elementRef, _viewRef) {
            this._overlayService = _overlayService;
            this._elementRef = _elementRef;
            this._viewRef = _viewRef;
            this.placement = 'bottom';
        }
        PopoverDirective.prototype.ngOnInit = function () {
            this._portal = new portal.ComponentPortal(PopoverWrapperComponent, this._viewRef);
        };
        PopoverDirective.prototype._onMouseEnter = function () {
            this._createOverlay();
        };
        PopoverDirective.prototype._onMouseLeave = function () {
            this._disposeOverlay();
        };
        PopoverDirective.prototype._createOverlay = function () {
            var wrapperInstance;
            var scrollStrategy = this._overlayService.scrollStrategies.reposition();
            var positionStrategy = this._overlayService.position()
                .flexibleConnectedTo(this._elementRef)
                .withPositions(this._getPositions());
            positionStrategy.positionChanges.subscribe(function (p) {
                wrapperInstance.placement = p.connectionPair.key;
            });
            this._overlayRef = this._overlayService.create({ scrollStrategy: scrollStrategy, positionStrategy: positionStrategy });
            wrapperInstance = this._overlayRef.attach(this._portal).instance;
            wrapperInstance.title = this.title;
            wrapperInstance.content = this.content;
            wrapperInstance.placement = this.placement;
        };
        PopoverDirective.prototype._getPositions = function () {
            var c = 'center', t = 'top', b = 'bottom', s = 'start', e = 'end';
            var top = { originX: c, originY: t, overlayX: c, overlayY: b, key: t };
            var bottom = { originX: c, originY: b, overlayX: c, overlayY: t, key: b };
            var start = { originX: s, originY: c, overlayX: e, overlayY: c, key: s };
            var end = { originX: e, originY: c, overlayX: s, overlayY: c, key: e };
            var positions;
            switch (this.placement) {
                case b:
                    positions = [bottom, top];
                    break;
                case s:
                    positions = [start, end];
                    break;
                case e:
                    positions = [end, start];
                    break;
                case t:
                    positions = [top, bottom];
                    break;
                default:
                    positions = [bottom, top];
            }
            return positions;
        };
        PopoverDirective.prototype._disposeOverlay = function () {
            if (this._overlayRef) {
                this._overlayRef.dispose();
                this._overlayRef = null;
            }
        };
        PopoverDirective.prototype.ngOnDestroy = function () {
            this._disposeOverlay();
        };
        return PopoverDirective;
    }());
    PopoverDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[jssPopover]',
                    exportAs: 'jssPopover',
                },] }
    ];
    PopoverDirective.ctorParameters = function () { return [
        { type: overlay.Overlay },
        { type: core.ElementRef },
        { type: core.ViewContainerRef }
    ]; };
    PopoverDirective.propDecorators = {
        title: [{ type: core.Input }],
        content: [{ type: core.Input, args: ['jssPopover',] }],
        placement: [{ type: core.Input }],
        _onMouseEnter: [{ type: core.HostListener, args: ['mouseenter',] }],
        _onMouseLeave: [{ type: core.HostListener, args: ['mouseleave',] }]
    };

    var PopoverModule = /** @class */ (function () {
        function PopoverModule(overlayService) {
            overlayService.injectCss();
        }
        return PopoverModule;
    }());
    PopoverModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        PopoverDirective,
                        PopoverWrapperComponent
                    ],
                    imports: [
                        common.CommonModule,
                        overlay.OverlayModule
                    ],
                    exports: [
                        PopoverDirective
                    ]
                },] }
    ];
    PopoverModule.ctorParameters = function () { return [
        { type: angular.CdkOverlayService }
    ]; };

    var TabDirective = /** @class */ (function () {
        function TabDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return TabDirective;
    }());
    TabDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[jssTab]',
                    exportAs: 'jssTab'
                },] }
    ];
    TabDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };
    TabDirective.propDecorators = {
        title: [{ type: core.Input }],
        disabled: [{ type: core.Input }]
    };

    var TabsComponent = /** @class */ (function () {
        function TabsComponent(_element, _renderer) {
            this._element = _element;
            this._renderer = _renderer;
            this.selectedIndex = 0;
            this.disabled = false;
            this.fade = true;
            this.appearance = 'default';
            this.vertical = false;
            this.tabSelect = new core.EventEmitter();
        }
        TabsComponent.prototype.ngOnInit = function () {
            var _this = this;
            ['jss-tabs'].forEach(function (x) { return _this._renderer.addClass(_this._element.nativeElement, x); });
        };
        TabsComponent.prototype._onTabClick = function (tab, index) {
            if (tab.disabled || this.disabled) {
                return;
            }
            this.selectedIndex = index;
            this.tabSelect.emit({ index: index, tab: tab });
        };
        return TabsComponent;
    }());
    TabsComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'jss-tabs',
                    exportAs: 'jssTabs',
                    template: "<ul class=\"nav\"\r\n    [class.nav-tabs]=\"appearance==='default' && !vertical\"\r\n    [class.nav-pills]=\"appearance==='pill' && !vertical\"\r\n    [class.flex-column]=\"vertical\"\r\n    role=\"tablist\">\r\n\r\n    <li *ngFor=\"let tab of tabs; index as i\" class=\"nav-item\" (click)=\"_onTabClick(tab, i)\">\r\n        <button *ngIf=\"!vertical\"\r\n                class=\"nav-link\"\r\n                [class.disabled]=\"tab.disabled || disabled\"\r\n                [class.active]=\"i===selectedIndex\"\r\n                aria-disabled=\"true\"\r\n                role=\"tab\">\r\n            {{tab.title}}\r\n        </button>\r\n\r\n        <a *ngIf=\"vertical\"\r\n           class=\"nav-link\"\r\n           aria-current=\"page\">\r\n            {{tab.title}}\r\n        </a>\r\n    </li>\r\n</ul>\r\n\r\n<div class=\"\" [className]=\"'tab-content ' + (contentCssClass ? contentCssClass : '')\">\r\n    <div *ngFor=\"let tab of tabs; index as i\" class=\"tab-pane\" [class.fade]=\"fade\"\r\n         [class.show]=\"i===selectedIndex\" [class.active]=\"i===selectedIndex\" role=\"tabpanel\">\r\n        <ng-container *ngTemplateOutlet=\"tab.templateRef;\"></ng-container>\r\n    </div>\r\n</div>",
                    host: {
                        '[class.jss-tabs-vertical]': 'vertical',
                    },
                    styles: [":host{display:flex;flex-direction:column}:host.jss-tabs-vertical{flex-direction:row}:host.jss-tabs-vertical .tab-content{flex-grow:1}a{cursor:pointer}"]
                },] }
    ];
    TabsComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 }
    ]; };
    TabsComponent.propDecorators = {
        tabs: [{ type: core.ContentChildren, args: [TabDirective,] }],
        selectedIndex: [{ type: core.Input }],
        disabled: [{ type: core.Input }],
        fade: [{ type: core.Input }],
        appearance: [{ type: core.Input }],
        vertical: [{ type: core.Input }],
        contentCssClass: [{ type: core.Input }],
        tabSelect: [{ type: core.Output }]
    };

    var DECLARES$1 = [
        TabsComponent,
        TabDirective
    ];
    var TabsModule = /** @class */ (function () {
        function TabsModule() {
        }
        return TabsModule;
    }());
    TabsModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                    ],
                    declarations: DECLARES$1,
                    exports: DECLARES$1
                },] }
    ];

    var TooltipWrapperComponent = /** @class */ (function () {
        function TooltipWrapperComponent(_elementRef, _renderer) {
            this._elementRef = _elementRef;
            this._renderer = _renderer;
        }
        TooltipWrapperComponent.prototype.ngOnInit = function () {
            var _this = this;
            var elm = this._elementRef.nativeElement;
            this._renderer.setAttribute(elm, 'role', 'tooltip');
            ['tooltip', 'fade', 'show'].forEach(function (c) { return _this._renderer.addClass(elm, c); });
        };
        Object.defineProperty(TooltipWrapperComponent.prototype, "_isStringContent", {
            get: function () {
                return typeof this.content === 'string';
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TooltipWrapperComponent.prototype, "_cssClass", {
            get: function () {
                var r = {};
                r['bs-tooltip-' + this.placement] = true;
                return r;
            },
            enumerable: false,
            configurable: true
        });
        return TooltipWrapperComponent;
    }());
    TooltipWrapperComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'jss-tooltip-wrapper',
                    exportAs: 'jssTooltipWrapper',
                    template: "<div class=\"tooltip-arrow\"></div>\r\n<div class=\"tooltip-inner\">\r\n    <ng-template [ngIf]=\"_isStringContent\" [ngIfElse]=\"contentTemplate\">{{content}}</ng-template>\r\n\r\n    <ng-template #contentTemplate>\r\n        <ng-container [ngTemplateOutlet]=\"content\"></ng-container>\r\n    </ng-template>\r\n</div>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [":host{position:relative}:host.bs-tooltip-bottom .tooltip-arrow,:host.bs-tooltip-top .tooltip-arrow{left:calc(50% - .5rem)}:host.bs-tooltip-end .tooltip-arrow,:host.bs-tooltip-start .tooltip-arrow{top:calc(50% - .5rem)}"]
                },] }
    ];
    TooltipWrapperComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 }
    ]; };
    TooltipWrapperComponent.propDecorators = {
        _cssClass: [{ type: core.HostBinding, args: ['class',] }]
    };

    var TooltipDirective = /** @class */ (function () {
        function TooltipDirective(_overlayService, _elementRef, _viewRef) {
            this._overlayService = _overlayService;
            this._elementRef = _elementRef;
            this._viewRef = _viewRef;
            this.placement = 'bottom';
        }
        TooltipDirective.prototype.ngOnInit = function () {
            this._portal = new portal.ComponentPortal(TooltipWrapperComponent, this._viewRef);
        };
        TooltipDirective.prototype._onMouseEnter = function () {
            this._createOverlay();
        };
        TooltipDirective.prototype._onMouseLeave = function () {
            this._disposeOverlay();
        };
        TooltipDirective.prototype._createOverlay = function () {
            var wrapperInstance;
            var scrollStrategy = this._overlayService.scrollStrategies.reposition();
            var positionStrategy = this._overlayService.position()
                .flexibleConnectedTo(this._elementRef)
                .withPositions(this._getPositions());
            positionStrategy.positionChanges.subscribe(function (p) {
                wrapperInstance.placement = p.connectionPair.key;
            });
            this._overlayRef = this._overlayService.create({ scrollStrategy: scrollStrategy, positionStrategy: positionStrategy });
            wrapperInstance = this._overlayRef.attach(this._portal).instance;
            wrapperInstance.content = this.content;
            wrapperInstance.placement = this.placement;
        };
        TooltipDirective.prototype._getPositions = function () {
            var c = 'center', t = 'top', b = 'bottom', s = 'start', e = 'end';
            var top = { originX: c, originY: t, overlayX: c, overlayY: b, key: t };
            var bottom = { originX: c, originY: b, overlayX: c, overlayY: t, key: b };
            var start = { originX: s, originY: c, overlayX: e, overlayY: c, key: s };
            var end = { originX: e, originY: c, overlayX: s, overlayY: c, key: e };
            var positions;
            switch (this.placement) {
                case 'bottom':
                    positions = [bottom, top];
                    break;
                case 'start':
                    positions = [start, start];
                    break;
                case 'end':
                    positions = [end, start];
                    break;
                case 'top':
                    positions = [top, bottom];
                    break;
                default:
                    positions = [bottom, top];
            }
            return positions;
        };
        TooltipDirective.prototype._disposeOverlay = function () {
            if (this._overlayRef) {
                this._overlayRef.dispose();
                this._overlayRef = null;
            }
        };
        TooltipDirective.prototype.ngOnDestroy = function () {
            this._disposeOverlay();
        };
        return TooltipDirective;
    }());
    TooltipDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[jssTooltip]',
                    exportAs: 'jssTooltip',
                },] }
    ];
    TooltipDirective.ctorParameters = function () { return [
        { type: overlay.Overlay },
        { type: core.ElementRef },
        { type: core.ViewContainerRef }
    ]; };
    TooltipDirective.propDecorators = {
        content: [{ type: core.Input, args: ['jssTooltip',] }],
        placement: [{ type: core.Input }],
        _onMouseEnter: [{ type: core.HostListener, args: ['mouseenter',] }],
        _onMouseLeave: [{ type: core.HostListener, args: ['mouseleave',] }]
    };

    var TooltipModule = /** @class */ (function () {
        function TooltipModule(overlayService) {
            overlayService.injectCss();
        }
        return TooltipModule;
    }());
    TooltipModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        TooltipDirective,
                        TooltipWrapperComponent
                    ],
                    imports: [
                        common.CommonModule,
                        overlay.OverlayModule
                    ],
                    exports: [
                        TooltipDirective
                    ]
                },] }
    ];
    TooltipModule.ctorParameters = function () { return [
        { type: angular.CdkOverlayService }
    ]; };

    exports.BadgeDirective = BadgeDirective;
    exports.BadgeModule = BadgeModule;
    exports.BreadcrumbComponent = BreadcrumbComponent;
    exports.BreadcrumbItemTemplateDirective = BreadcrumbItemTemplateDirective;
    exports.BreadcrumbModule = BreadcrumbModule;
    exports.ButtonDirective = ButtonDirective;
    exports.ButtonModule = ButtonModule;
    exports.CardComponent = CardComponent;
    exports.CardFooterDirective = CardFooterDirective;
    exports.CardHeaderDirective = CardHeaderDirective;
    exports.CardModule = CardModule;
    exports.NavbarCollapseDirective = NavbarCollapseDirective;
    exports.NavbarModule = NavbarModule;
    exports.PopoverDirective = PopoverDirective;
    exports.PopoverModule = PopoverModule;
    exports.PopoverWrapperComponent = PopoverWrapperComponent;
    exports.TabDirective = TabDirective;
    exports.TabsComponent = TabsComponent;
    exports.TabsModule = TabsModule;
    exports.TooltipDirective = TooltipDirective;
    exports.TooltipModule = TooltipModule;
    exports.TooltipWrapperComponent = TooltipWrapperComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=js-sugar-angular-bootstrap.umd.js.map
